#pragma once

#include <cigui/utils/Vectors.hpp>


namespace cig
{
	enum class LayoutSizes : uint8_t
	{
		None = 0,
		Min,
		Max,
		Fixed,
	};

	enum class LayoutAlignment : uint8_t
	{
		None = 0,
		Left,
		Right,
		Top,
		Bottom,
		Center,
	};

	enum class LayoutDirection : uint8_t
	{
		None = 0,
		LeftToRight,
		RightToLeft,
		TopToBottom,
		BottomToTop,
	};

	enum class LayoutPosition : uint8_t
	{
		None = 0,
		Absolute,
		Left,
		Right,
		Top,
		Bottom,
		Center,
	};

	struct Layout
	{
		struct
		{
			LayoutSizes rule = LayoutSizes::None;
			vec2f minSize = {0.f, 0.f};
			vec2f maxSize = {0.f, 0.f};
		} size;

		struct
		{
			LayoutAlignment rule = LayoutAlignment::None;
			vec4f padding = {0.f, 0.f, 0.f, 0.f};
			vec4f margin = {0.f, 0.f, 0.f, 0.f};
		} alignment;

		struct
		{
			LayoutDirection rule = LayoutDirection::None;
			vec2f spacing = {0.f, 0.f};
		} direction;

		struct
		{
			LayoutPosition rule = LayoutPosition::None;
			vec2f position = {0.f, 0.f};
		} position;
	};
}
