﻿#pragma once

#include <cigui/core/Layout.hpp>
#include <cigui/utils/List.hpp>

#include <memory>

namespace cig
{
	class RenderCall;

	class View {
	protected:
		List<RenderCall> m_RenderCalls;
		Layout m_Layout;

	public:
		virtual ~View() = default;

		[[nodiscard]] const List<RenderCall>& renderCalls() const;
		std::unique_ptr<View> content;

		virtual bool update();

		void draw();

		virtual View *body() = 0;
	};
}