#pragma once

#include <cigui/config.h>

#include <stdint.h>


#define TYPEDEF_VECTOR(NAME, T, N, s) typedef NAME<T> vec##N##s;

#define TYPEDEF_VECTORS(NAME, N)              \
  typedef NAME<float> vec##N;                 \
  TYPEDEF_VECTOR(NAME, float, N, f)           \
  TYPEDEF_VECTOR(NAME, double, N, d)          \
  TYPEDEF_VECTOR(NAME, long double, N, ld)    \
  TYPEDEF_VECTOR(NAME, size_t, N, sz)         \
  TYPEDEF_VECTOR(NAME, int, N, i)             \
  TYPEDEF_VECTOR(NAME, unsigned int, N, u)    \
  TYPEDEF_VECTOR(NAME, short, N, s)           \
  TYPEDEF_VECTOR(NAME, unsigned short, N, us) \
  TYPEDEF_VECTOR(NAME, long, N, l)            \
  TYPEDEF_VECTOR(NAME, unsigned long, N, ul)  \
  TYPEDEF_VECTOR(NAME, long long, N, ll)      \
  TYPEDEF_VECTOR(NAME, unsigned long long, N, ull)

#if defined(__GNUC__) || defined(__clang__)
#define UNNAMED_STRUCT __extension__ struct
#else
	#defien UNNAMED_STRUCT struct
#endif

#if CIGUI_DLL
#define VECTOR_TEMPLATE_INST(N, T) CIGUI_TEMPLATE_INST Vector##N<T>; \

#define VECTOR_INSTANTIATION(N) \
	VECTOR_TEMPLATE_INST(N, float) \
	VECTOR_TEMPLATE_INST(N, double)\
	VECTOR_TEMPLATE_INST(N, long double) \
	VECTOR_TEMPLATE_INST(N, size_t) \
	VECTOR_TEMPLATE_INST(N, int) \
	VECTOR_TEMPLATE_INST(N, short) \
	VECTOR_TEMPLATE_INST(N, long) \
	VECTOR_TEMPLATE_INST(N, long long) \
	VECTOR_TEMPLATE_INST(N, unsigned int) \
	VECTOR_TEMPLATE_INST(N, unsigned short) \
	VECTOR_TEMPLATE_INST(N, unsigned long) \
	VECTOR_TEMPLATE_INST(N, unsigned long long)
#else
#define VECTOR_INSTANTIATION(N)
#endif


namespace cig
{
	template <typename T>
	union Vector2
	{
		UNNAMED_STRUCT
		{
			T x, y;
		};

		UNNAMED_STRUCT
		{
			T a, b;
		};
	};

	TYPEDEF_VECTORS(Vector2, 2)

	template <typename T>
	union Vector3
	{
		UNNAMED_STRUCT
		{
			T x, y, z;
		};

		UNNAMED_STRUCT
		{
			T r, g, b;
		};
	};

	TYPEDEF_VECTORS(Vector3, 3)

	template <typename T>
	union Vector4
	{
		UNNAMED_STRUCT
		{
			T x, y, z, w;
		};

		UNNAMED_STRUCT
		{
			T r, g, b, a;
		};

		UNNAMED_STRUCT
		{
			T left, top, right, bottom;
		};
	};

	TYPEDEF_VECTORS(Vector4, 4)
}
