﻿#include <cigui/core/Renderer.hpp>

#include <cigui/core/View.hpp>
#include <cigui/core/RenderCall.hpp>
#include <sfml/Graphics.hpp>

namespace cig {
	Renderer::Renderer(View *_view) : view(_view) { view->draw(); }

	void Renderer::update() const {
		if (view->update())
			view->draw();
	}

	void Renderer::render(sf::RenderTarget &target, const sf::RenderStates &states) const {
		auto lambda = [&target, &states](const RenderCall &renderCall) { renderCall.draw(target, states); };
		view->renderCalls().iterate(lambda);
	}
}