﻿#include <cigui/core/View.hpp>

#include <cigui/core/RenderCall.hpp>

namespace cig {
	const List<RenderCall>& View::renderCalls() const
	{
		return m_RenderCalls;
	}

	void View::draw() {
		if (!m_RenderCalls.empty()) {
			m_RenderCalls.clear();
		}
		content = std::unique_ptr<View>(body());
		if (!content) {
			return;
		}
		content->draw();
		auto &contentRenderCalls = content->renderCalls();
		m_RenderCalls.expand(contentRenderCalls);
	}

	bool View::update() {
		if (content)
			return content->update();
		return false;
	}
}